#!/usr/bin/env python
# coding: utf-8

from multiprocessing import Pool

import glob
import os
import sys

import dplume

def get_fnames(origin, product):

    path =  "/project/kug/smartcarb/results/%s/plume_detection_mc" % origin
    print(os.path.join(path, product))
    filenames = sorted(glob.glob(
        os.path.join(path, product, "*.nc")
    ))
    return filenames



if __name__ == '__main__':

    origin = 'Berlin'
    product = dplume.io.get_product(tracer='NO2', ssp='S5', q=0.99, ns=5,
                                    use_s5=True)

    filenames = get_fnames(origin, product)
    n = len(filenames)


    columns = ['utc', 'orbit', 'lon_eq', 'detected_pixels',
               'CO2_pixels', 'NO2_pixels', 'TP', 'FP', 'TN', 'FN', 'PPV']

    out_filename = '%s.dat' % product

    with open(out_filename, 'w') as out:

        out.write('\t'.join(columns))
        out.write('\n')

        for i in range(0,n,100):
            with Pool(processes=20) as pool:
                res = pool.map(dplume.extract_mc_detection, filenames[i:i+100])

            for line in res:
                sys.stdout.write('\r')
                sys.stdout.write(line)
                sys.stdout.flush()

                out.write(line)
                out.write('\n')


